



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>DataTable数据集转换为List非泛型以及泛型方式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">DataTable数据集转换为List非泛型以及泛型方式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 17:08:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前言</p>
<p>DataTable是断开式的数据集合，所以一旦从数据库获取，就会在内存中创建一个数据的副本，以便使用。由于在实际项目中，经常会将DataTable中的每行数据转换为Model，然后放到List集合中，所以，下面提供了转换的两种思路：非泛型转换思路和泛型转换思路。</p>
<p>非泛型方式</p>
<p>首先来说下非泛型转换，这种转换方式就是通过遍历DataTable，然后向Model中的相同字段中赋值即可。</p>
<div>
<pre class="prettyprint linenums"> //使用Linq的ToList方法，非泛型</pre>
<pre class="prettyprint linenums">        public static List&lt;Entity&gt; ConvertTo(DataTable dt)</pre>
<pre class="prettyprint linenums">        {</pre>
<pre class="prettyprint linenums">            if (dt == null) return null;</pre>
<pre class="prettyprint linenums">            if (dt.Rows.Count &lt;= 0) return null;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">            List&lt;Entity&gt; list = new List&lt;Entity&gt;();</pre>
<pre class="prettyprint linenums">            list = (from DataRow dr in dt.Rows</pre>
<pre class="prettyprint linenums">                    select new Entity</pre>
<pre class="prettyprint linenums">                    {</pre>
<pre class="prettyprint linenums">                        PID = Int32.Parse(dr["PID"].ToString()),</pre>
<pre class="prettyprint linenums">                        PName = dr["PName"].ToString(),</pre>
<pre class="prettyprint linenums">                        PPass = dr["PPass"].ToString(),</pre>
<pre class="prettyprint linenums">                        PAddr = dr["PAddr"].ToString()</pre>
<pre class="prettyprint linenums">                    }).ToList();</pre>
<pre class="prettyprint linenums">            return list;</pre>
<pre class="prettyprint linenums">        }</pre>
</div>
<p><!--<br />
.csharpcode, .csharpcode pre<br />
{<br />
	font-size: small;<br />
	color: black;<br />
	font-family: consolas, "Courier New", courier, monospace;<br />
	background-color: #ffffff;<br />
	/*white-space: pre;*/<br />
}<br />
.csharpcode pre { margin: 0em; }<br />
.csharpcode .rem { color: #008000; }<br />
.csharpcode .kwrd { color: #0000ff; }<br />
.csharpcode .str { color: #006080; }<br />
.csharpcode .op { color: #0000c0; }<br />
.csharpcode .preproc { color: #cc6633; }<br />
.csharpcode .asp { background-color: #ffff00; }<br />
.csharpcode .html { color: #800000; }<br />
.csharpcode .attr { color: #ff0000; }<br />
.csharpcode .alt<br />
{<br />
	background-color: #f4f4f4;<br />
	width: 100%;<br />
	margin: 0em;<br />
}<br />
.csharpcode .lnum { color: #606060; }<br />
--></p>
<p>代码很简单，就是通过循环赋值而已。这里我用的Model测试类如下：</p>
<div>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">namespace DataSetToEntity.Code</pre>
<pre class="prettyprint linenums">{</pre>
<pre class="prettyprint linenums">    public class Entity</pre>
<pre class="prettyprint linenums">    {</pre>
<pre class="prettyprint linenums">        public int PID { get; set; }</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">        public string PName { get; set; }</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">        public string PPass { get; set; }</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">        public string PAddr { get; set; }</pre>
<pre class="prettyprint linenums">    }</pre>
<pre class="prettyprint linenums">}</pre>
</div>
<p><!--<br />
.csharpcode, .csharpcode pre<br />
{<br />
	font-size: small;<br />
	color: black;<br />
	font-family: consolas, "Courier New", courier, monospace;<br />
	background-color: #ffffff;<br />
	/*white-space: pre;*/<br />
}<br />
.csharpcode pre { margin: 0em; }<br />
.csharpcode .rem { color: #008000; }<br />
.csharpcode .kwrd { color: #0000ff; }<br />
.csharpcode .str { color: #006080; }<br />
.csharpcode .op { color: #0000c0; }<br />
.csharpcode .preproc { color: #cc6633; }<br />
.csharpcode .asp { background-color: #ffff00; }<br />
.csharpcode .html { color: #800000; }<br />
.csharpcode .attr { color: #ff0000; }<br />
.csharpcode .alt<br />
{<br />
	background-color: #f4f4f4;<br />
	width: 100%;<br />
	margin: 0em;<br />
}<br />
.csharpcode .lnum { color: #606060; }<br />
--></p>
<p>泛型方式</p>
<p>然后，由于非泛型的版本不具有通用性，所以这里我们准备用泛型版本来实现一下，由于泛型版本是不可预知Model中的属性结构的，所以这里我们需要引入反射来进行操作。</p>
<div>
<div>
<pre class="prettyprint linenums">//使用反射的泛型方法一</pre>
<pre class="prettyprint linenums">        public static List&lt;T&gt; ConvertTo&lt;T&gt;(DataTable dt) where T : new()</pre>
<pre class="prettyprint linenums">        {</pre>
<pre class="prettyprint linenums">            if (dt == null) return null;</pre>
<pre class="prettyprint linenums">            if (dt.Rows.Count &lt;= 0) return null;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">            List&lt;T&gt; list = new List&lt;T&gt;();</pre>
<pre class="prettyprint linenums">            try</pre>
<pre class="prettyprint linenums">            {</pre>
<pre class="prettyprint linenums">                List&lt;string&gt; columnsName = new List&lt;string&gt;();  </pre>
<pre class="prettyprint linenums">                foreach (DataColumn dataColumn in dt.Columns)</pre>
<pre class="prettyprint linenums">                {</pre>
<pre class="prettyprint linenums">                    columnsName.Add(dataColumn.ColumnName);//得到所有的表头</pre>
<pre class="prettyprint linenums">                }</pre>
<pre class="prettyprint linenums">                list = dt.AsEnumerable().ToList().ConvertAll&lt;T&gt;(row =&gt; getObject&lt;T&gt;(row, columnsName));  //转换</pre>
<pre class="prettyprint linenums">                return list;</pre>
<pre class="prettyprint linenums">            }</pre>
<pre class="prettyprint linenums">            catch (Exception ex)</pre>
<pre class="prettyprint linenums">            {</pre>
<pre class="prettyprint linenums">                return null;</pre>
<pre class="prettyprint linenums">            }</pre>
<pre class="prettyprint linenums">        }</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">        public static T getObject&lt;T&gt;(DataRow row, List&lt;string&gt; columnsName) where T : new()</pre>
<pre class="prettyprint linenums">        {</pre>
<pre class="prettyprint linenums">            T obj = new T();</pre>
<pre class="prettyprint linenums">            try</pre>
<pre class="prettyprint linenums">            {</pre>
<pre class="prettyprint linenums">                string columnname = "";</pre>
<pre class="prettyprint linenums">                string value = "";</pre>
<pre class="prettyprint linenums">                PropertyInfo[] Properties = typeof(T).GetProperties();</pre>
<pre class="prettyprint linenums">                foreach (PropertyInfo objProperty in Properties)  //遍历T的属性</pre>
<pre class="prettyprint linenums">                {</pre>
<pre class="prettyprint linenums">                    columnname = columnsName.Find(name =&gt; name.ToLower() == objProperty.Name.ToLower()); //寻找可以匹配的表头名称</pre>
<pre class="prettyprint linenums">                    if (!string.IsNullOrEmpty(columnname))</pre>
<pre class="prettyprint linenums">                    {</pre>
<pre class="prettyprint linenums">                        value = row[columnname].ToString();</pre>
<pre class="prettyprint linenums">                        if (!string.IsNullOrEmpty(value))</pre>
<pre class="prettyprint linenums">                        {</pre>
<pre class="prettyprint linenums">                            if (Nullable.GetUnderlyingType(objProperty.PropertyType) != null) //存在匹配的表头</pre>
<pre class="prettyprint linenums">                            {</pre>
<pre class="prettyprint linenums">                                value = row[columnname].ToString().Replace("$", "").Replace(",", ""); //从dataRow中提取数据</pre>
<pre class="prettyprint linenums">                                objProperty.SetValue(obj, Convert.ChangeType(value, Type.GetType(Nullable.GetUnderlyingType(objProperty.PropertyType).ToString())), null); //赋值操作</pre>
<pre class="prettyprint linenums">                            }</pre>
<pre class="prettyprint linenums">                            else</pre>
<pre class="prettyprint linenums">                            {</pre>
<pre class="prettyprint linenums">                                value = row[columnname].ToString().Replace("%", ""); //存在匹配的表头</pre>
<pre class="prettyprint linenums">                                objProperty.SetValue(obj, Convert.ChangeType(value, Type.GetType(objProperty.PropertyType.ToString())), null);//赋值操作</pre>
<pre class="prettyprint linenums">                            }</pre>
<pre class="prettyprint linenums">                        }</pre>
<pre class="prettyprint linenums">                    }</pre>
<pre class="prettyprint linenums">                }</pre>
<pre class="prettyprint linenums">                return obj;</pre>
<pre class="prettyprint linenums">            }</pre>
<pre class="prettyprint linenums">            catch</pre>
<pre class="prettyprint linenums">            {</pre>
<pre class="prettyprint linenums">                return obj;</pre>
<pre class="prettyprint linenums">            }</pre>
<pre class="prettyprint linenums">        }</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">上面主要是通过反射获取T的属性名称，然后和DataRow中的表头相匹配，如果匹配的上，就赋值。下面是其简化版本：</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<div>
<pre class="prettyprint linenums">//使用反射的泛型方法二</pre>
<pre class="prettyprint linenums">        public static List&lt;T&gt; ConvertToEx&lt;T&gt;(DataTable dt) where T : new()</pre>
<pre class="prettyprint linenums">        {</pre>
<pre class="prettyprint linenums">            if (dt == null) return null;</pre>
<pre class="prettyprint linenums">            if (dt.Rows.Count &lt;= 0) return null;</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">            List&lt;T&gt; list = new List&lt;T&gt;();</pre>
<pre class="prettyprint linenums">            Type type = typeof(T);</pre>
<pre class="prettyprint linenums">            PropertyInfo[] propertyInfos = type.GetProperties();  //获取泛型的属性</pre>
<pre class="prettyprint linenums">            List&lt;DataColumn&gt; listColumns = dt.Columns.Cast&lt;DataColumn&gt;().ToList();  //获取数据集的表头，以便于匹配</pre>
<pre class="prettyprint linenums">            T t;</pre>
<pre class="prettyprint linenums">            foreach (DataRow dr in dt.Rows)   </pre>
<pre class="prettyprint linenums">            {</pre>
<pre class="prettyprint linenums">                t = new T();</pre>
<pre class="prettyprint linenums">                foreach (PropertyInfo propertyInfo in propertyInfos)</pre>
<pre class="prettyprint linenums">                {</pre>
<pre class="prettyprint linenums">                    try</pre>
<pre class="prettyprint linenums">                    {</pre>
<pre class="prettyprint linenums">                        DataColumn dColumn = listColumns.Find(name =&gt; name.ToString().ToUpper() == propertyInfo.Name.ToUpper());  //查看是否存在对应的列名</pre>
<pre class="prettyprint linenums">                        if (dColumn != null)</pre>
<pre class="prettyprint linenums">                            propertyInfo.SetValue(t, dr[propertyInfo.Name], null);  //赋值</pre>
<pre class="prettyprint linenums">                    }</pre>
<pre class="prettyprint linenums">                    catch (Exception ex)</pre>
<pre class="prettyprint linenums">                    {</pre>
<pre class="prettyprint linenums">                        throw new Exception(ex.Message);</pre>
<pre class="prettyprint linenums">                    }</pre>
<pre class="prettyprint linenums">                }</pre>
<pre class="prettyprint linenums">                list.Add(t);</pre>
<pre class="prettyprint linenums">            }</pre>
<pre class="prettyprint linenums">            return list;</pre>
<pre class="prettyprint linenums">        }</pre>
</div>
<div>&nbsp;</div>
<div>至于使用方式，很简单，直接利用下面的代码即可：</div>
<pre class="prettyprint linenums"> List&lt;Entity&gt; list = CommonUtils.ConvertToEx&lt;Entity&gt;(dt);</pre>
</div>
</div>
<p><!--<br />
.csharpcode, .csharpcode pre<br />
{<br />
	font-size: small;<br />
	color: black;<br />
	font-family: consolas, "Courier New", courier, monospace;<br />
	background-color: #ffffff;<br />
	/*white-space: pre;*/<br />
}<br />
.csharpcode pre { margin: 0em; }<br />
.csharpcode .rem { color: #008000; }<br />
.csharpcode .kwrd { color: #0000ff; }<br />
.csharpcode .str { color: #006080; }<br />
.csharpcode .op { color: #0000c0; }<br />
.csharpcode .preproc { color: #cc6633; }<br />
.csharpcode .asp { background-color: #ffff00; }<br />
.csharpcode .html { color: #800000; }<br />
.csharpcode .attr { color: #ff0000; }<br />
.csharpcode .alt<br />
{<br />
	background-color: #f4f4f4;<br />
	width: 100%;<br />
	margin: 0em;<br />
}<br />
.csharpcode .lnum { color: #606060; }<br />
--><br />
<!--<br />
.csharpcode, .csharpcode pre<br />
{<br />
	font-size: small;<br />
	color: black;<br />
	font-family: consolas, "Courier New", courier, monospace;<br />
	background-color: #ffffff;<br />
	/*white-space: pre;*/<br />
}<br />
.csharpcode pre { margin: 0em; }<br />
.csharpcode .rem { color: #008000; }<br />
.csharpcode .kwrd { color: #0000ff; }<br />
.csharpcode .str { color: #006080; }<br />
.csharpcode .op { color: #0000c0; }<br />
.csharpcode .preproc { color: #cc6633; }<br />
.csharpcode .asp { background-color: #ffff00; }<br />
.csharpcode .html { color: #800000; }<br />
.csharpcode .attr { color: #ff0000; }<br />
.csharpcode .alt<br />
{<br />
	background-color: #f4f4f4;<br />
	width: 100%;<br />
	margin: 0em;<br />
}<br />
.csharpcode .lnum { color: #606060; }<br />
--><br />
<!--<br />
.csharpcode, .csharpcode pre<br />
{<br />
	font-size: small;<br />
	color: black;<br />
	font-family: consolas, "Courier New", courier, monospace;<br />
	background-color: #ffffff;<br />
	/*white-space: pre;*/<br />
}<br />
.csharpcode pre { margin: 0em; }<br />
.csharpcode .rem { color: #008000; }<br />
.csharpcode .kwrd { color: #0000ff; }<br />
.csharpcode .str { color: #006080; }<br />
.csharpcode .op { color: #0000c0; }<br />
.csharpcode .preproc { color: #cc6633; }<br />
.csharpcode .asp { background-color: #ffff00; }<br />
.csharpcode .html { color: #800000; }<br />
.csharpcode .attr { color: #ff0000; }<br />
.csharpcode .alt<br />
{<br />
	background-color: #f4f4f4;<br />
	width: 100%;<br />
	margin: 0em;<br />
}<br />
.csharpcode .lnum { color: #606060; }<br />
--></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7rryx8.html">Legolas工业自动化平台入门（二）数据响应动作</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96xyd49.html">JavaScript系列：《JavaScript高级程序设计》，chapter2， 在html中使用JavaScript</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yd10nq.html">java 数据库连接池 Oracle版</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjyzrd9.html">CSS浏览器兼容性----Hack</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpnrzr9.html">keystore 介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkyvyz8.html">NOIP 2002 提高组 字串变换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1jwvyq.html">Oracle日期时间操作大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjz62r8.html">Qt 之 qwt 和 qwtpolar</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojr3gxq.html">CMS垃圾收集器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me54x2q.html">&lbrack;Inside HotSpot&rsqb; hotspot的启动流程与main方法调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd2lvd9.html">socket通讯，TCP，UDP，HTTP的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w7oznq.html">Spark SQL configuration</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o2x2x8.html">js获取css样式封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/960z1449.html">setting-mirrorO以及下载jar包流程简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2v6z2q.html">nodejs async series 小白向</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4nede9.html">iOS响应链原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlreyr9.html">padright padleft</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlwl3k9.html">web api解决序列化后返回标准时间带T问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql12jge9.html">（C&plus;&plus;）i&plus;&plus;和&plus;&plus;i，哪个效率高一些</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pl3208.html">【J2EE之web应用】java集群概念</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9pl6mdq.html">iOS开发之网络编程--获取文件的MIMEType</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4l5558.html">layout&lowbar;weight的使用说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv4ppxq.html">block的用法以及block和delegate的比较（转发）</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw3p3l9.html">UVa 103 - Stacking Boxes（dp求解）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9ploxdq.html">使用 ServiceStack&period;Text 序列化 json 比Json&period;net更快</a>
			</li>
						<li><a href="https://www.batexi.com/a/4952oxv9.html">&period;NET 分页</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq11065q.html">HTML5与触摸界面</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96v17v8.html">Programming ActionScript 3&period;0 for Flash</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx71yv9.html">Tomcat 长连接与短连接性能测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq11ewzq.html">HBase性能调优</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
